Clipboard in React DOCX Editor

27 Aug 20265 minutes to read

React DOCX Editor (Document Editor) takes advantage of the system clipboard and allows you to copy or move portions of the document to the clipboard in HTML format, so that it can be pasted into any application that supports clipboard operations.

Copy

Copy a portion of the document to the system clipboard using the built-in context menu of the DOCX Editor. You can also do it programmatically using the following sample code.

documentEditor.selection.copy();

Cut

Cut a portion of the document to the system clipboard using the built-in context menu of the DOCX Editor. You can also do it programmatically using the following sample code.

documentEditor.editor.cut();

Paste

Due to limitations, you can paste contents from the system clipboard into the DOCX Editor only using the Ctrl + V keyboard shortcut.

NOTE

Due to browser limitations of getting content from the system clipboard, paste using the API and context menu options doesn’t work.

Local paste (copy/paste within control)

DOCX Editor exposes an API to enable local paste within the control. When enabled, the following occurs:

  • Selected contents will be stored to an internal clipboard as SFDT in addition to the system clipboard.
  • Clipboard paste will be overridden, and the internally stored data (SFDT data) that has formatted text will be pasted using the paste() API in the DOCX Editor.

Enable Local Paste

Refer to the following sample code.

import * as React from 'react';
import { createRoot } from 'react-dom/client';
import {
  DocumentEditorComponent,
  SfdtExport,
  Selection,
  Editor,
} from '@syncfusion/ej2-react-documenteditor';

//Inject required modules.
DocumentEditorComponent.Inject(Selection, Editor);

function App() {
  let documenteditor;
  React.useEffect(() => {
    //Enable document editor local paste option.
    documenteditor.enableLocalPaste = true;
  }, []);
  return (
    <div>
      <DocumentEditorComponent
        id="container"
        ref={(scope) => {
          documenteditor = scope;
        }}
        isReadOnly={false}
        enableSelection={true}
        enableEditor={true}
      />
    </div>
  );
}
export default App;
const root = createRoot(document.getElementById('sample')!);
root.render(<App />);

By default, enableLocalPaste is false.
When local paste is enabled for a DOCX Editor instance, you can paste contents programmatically if the internal clipboard has stored data during last copy operation. Refer to the following sample code.

documentEditor.editor.paste();

Paste options in context menu

In the DOCX Editor, paste options in the context menu will be in a disabled state if you try to copy/paste content from outside of the DOCX Editor. It gets enabled when enableLocalPaste is true and you copy/paste content within the DOCX Editor.

NOTE

Due to browser limitations of getting content from the system clipboard, paste using the API and context menu options doesn’t work. Hence, the paste option is disabled in the context menu.

Alternatively, you can use the keyboard shortcuts:

  • Cut: Ctrl + X
  • Copy: Ctrl + C
  • Paste: Ctrl + V

EnableLocalPaste behavior

EnableLocalPaste Paste behavior details
True Allows to paste content that is copied from the same DOCX Editor component alone and prevents pasting content from system clipboard. Hence the content copied from outside DOCX Editor component can’t be pasted.
Browser limitation of pasting from system clipboard using API and context menu options, will be resolved. So, you can copy and paste content within the DOCX Editor component using API and context menu options too.
False Allows to paste content from system clipboard. Hence the content copied from both the DOCX Editor component and outside can be pasted.
Browser limitation of pasting from system clipboard using API and context menu options, will remain as a limitation.

NOTE

  • Keyboard shortcut for pasting will work properly in both cases.
  • Copying content from the DOCX Editor component and pasting outside will work properly in both cases.

Paste with formatting

DOCX Editor provides support to paste the system clipboard data with formatting. To enable clipboard paste with formatting options, set the enableLocalPaste property in the DOCX Editor to false and use the Syncfusion.EJ2.WordEditor.AspNet.Core .NET Standard library for the ASP.NET Core web API service implementation. This library helps you to paste the system clipboard data with formatting. For details on setting up the web API service, refer to the web services overview.

You can paste your system clipboard data in the following ways:

  • Keep Source Formatting: This option retains the character styles and direct formatting applied to the copied text. Direct formatting includes characteristics such as font size, italics, or other formatting that is not included in the paragraph style.
  • Match Destination Formatting: This option discards most of the formatting applied directly to the copied text, but it retains the formatting applied for emphasis, such as bold and italic when it is applied to only a portion of the selection. The text takes on the style characteristics of the paragraph where it is pasted. The text also takes on any direct formatting or character style properties of text that immediately precedes the cursor when the text is pasted.
  • Text Only: This option discards all formatting and non-text elements such as pictures or tables. The text takes on the style characteristics of the paragraph where it is pasted and takes on any direct formatting or character style properties of text that immediately precedes the cursor when the text is pasted. Graphical elements are discarded, and tables are converted to a series of paragraphs.

This paste option appears as follows.

Image

NOTE

When you paste content from an external source into the DOCX Editor, some formatting or elements may not appear as expected because certain elements are not supported. Refer here to learn more about unsupported elements.

See Also

Clipboard in Angular DOCX Editor

27 Aug 20265 minutes to read

Angular DOCX Editor (Document Editor) takes advantage of the system clipboard and allows you to copy or move a portion of the document into the clipboard in HTML format, so that it can be pasted in any application that supports clipboard.

Copy

Copy a portion of the document to the system clipboard using the built-in context menu of the DOCX Editor. You can also do it programmatically using the following sample code.

this.documentEditor.selection.copy();

Cut

Cut a portion of the document to the system clipboard using the built-in context menu of the DOCX Editor. You can also do it programmatically using the following sample code.

this.documentEditor.editor.cut();

Paste

Due to limitations, you can paste contents from the system clipboard in the DOCX Editor only using the ‘CTRL + V’ keyboard shortcut.

NOTE

Due to browser limitation of getting content from the system clipboard, paste using the API and context menu option doesn’t work.

Local paste (copy/paste within control)

DOCX Editor exposes an API to enable local paste within the control. On enabling this, the following is performed:

  • Selected contents will be stored to an internal clipboard in addition to the system clipboard.
  • Clipboard paste will be overridden, and internally stored data (SFDT data) that has formatted text will be pasted using paste() API in the DOCX Editor.

Refer to the following sample code.

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';
import { DocumentEditorAllModule } from '@syncfusion/ej2-angular-documenteditor';
import { ToolbarModule } from '@syncfusion/ej2-angular-navigations';

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import {
  DocumentEditorComponent,
  EditorService,
  SelectionService,
} from '@syncfusion/ej2-angular-documenteditor';

@Component({
  imports: [
    ButtonModule,
    ToolbarModule,
    DocumentEditorAllModule,
    ComboBoxModule,
    ColorPickerModule,
  ],

  standalone: true,
  selector: 'app-container',
  //specifies the template string for the Document Editor component
  template: `<div><button ejs-button (click)="pasteLocal()" >Paste local</button>
    <ejs-documenteditor #document_editor [enableSelection]='true' [isReadOnly]='false' [enableEditor]=true [enableLocalPaste]=true height="330px" style="display:block"></ejs-documenteditor>
      </div>`,
  encapsulation: ViewEncapsulation.None,
  //Provide necessary service.
  providers: [
    EditorService,
    SelectionService
  ],
})
export class AppComponent {
  @ViewChild('document_editor')
  public documentEditor?: DocumentEditorComponent;

  public pasteLocal(): void {
    //paste copied content.
    this.documentEditor?.editor.paste();
  }
}

By default, enableLocalPaste is false.
When local paste is enabled for a DOCX Editor instance, you can paste contents programmatically if the internal clipboard has stored data during the last copy operation. Refer to the following sample code.

this.documentEditor.editor.paste();

Paste options in context menu

In DOCX Editor, paste options in the context menu will be in disabled state if you try to copy/paste content from outside of the DOCX Editor. It gets enabled when enableLocalPaste is true and trying to copy/paste content inside the DOCX Editor.

NOTE

Due to browser limitation of getting content from system clipboard, paste using API and context menu option doesn’t work. Hence, the paste option is disabled in context menu.
Alternatively, you can use the keyboard shortcuts,

  • Cut: Ctrl + X
  • Copy: Ctrl + C
  • Paste: Ctrl + V

EnableLocalPaste behavior

EnableLocalPaste Paste behavior details
True Allows to paste content that is copied from the same DOCX Editor component alone and prevents pasting content from system clipboard. Hence the content copied from outside DOCX Editor component can’t be pasted.
Browser limitation of pasting from system clipboard using API and context menu options, will be resolved. So, you can copy and paste content within the DOCX Editor component using API and context menu options too.
False Allows to paste content from system clipboard. Hence the content copied from both the DOCX Editor component and outside can be pasted.
Browser limitation of pasting from system clipboard using API and context menu options, will remain as a limitation.

NOTE

  • Keyboard shortcut for pasting will work properly in both cases.
  • Copying content from DOCX Editor component and pasting outside will work properly in both cases.

Paste with formatting

DOCX Editor provides support to paste the system clipboard data with formatting. To enable clipboard paste with formatting options, set the enableLocalPaste property in DOCX Editor to false and use this .NET Standard library Syncfusion.EJ2.WordEditor.AspNet.Core by the web API service implementation. This library helps you to paste the system clipboard data with formatting.

Refer this page for more details.

You can paste your system clipboard data in the following ways:

  • Keep Source Formatting This option retains the character styles and direct formatting applied to the copied text. Direct formatting includes characteristics such as font size, italics, or other formatting that is not included in the paragraph style.
  • Match Destination Formatting This option discards most of the formatting applied directly to the copied text, but it retains the formatting applied for emphasis, such as bold and italic when it is applied to only a portion of the selection. The text takes on the style characteristics of the paragraph where it is pasted. The text also takes on any direct formatting or character style properties of text that immediately precedes the cursor when the text is pasted.
  • Text Only This option discards all formatting and non-text elements such as pictures or tables. The text takes on the style characteristics of the paragraph where it is pasted and takes on any direct formatting or character style properties of text that immediately precedes the cursor when the text is pasted. Graphical elements are discarded and tables are converted to a series of paragraphs.

This paste option appears as follows.

Image

NOTE

When you paste content from an external source into the DOCX Editor, some formatting or elements may not appear as expected because certain elements are not supported. Refer here to learn more about unsupported elements.

See Also